<template>
  <!-- Table Container Card -->
    <b-card
      no-body
      class="mb-0"
    >

      <div class="m-2">
        <h2>Lista de roles</h2>
        <!-- Table Top -->
        <b-row>

           <!-- Search -->
          <b-col
            cols="12"
            md="6"
            class="d-flex align-items-center justify-content-start mb-1 mb-md-0"
          >
             <b-form-input
                v-model="searchQuery"
                class="d-inline-block mr-1"
                placeholder="Search..."
              />
          </b-col>
          <!-- Add client button -->
          <b-col
            cols="12"
            md="6"
          >
            <div class="d-flex align-items-center justify-content-end">
             
              <b-button
                variant="primary"
                @click="$router.push({ name: 'apps-roles-create' })"
              >
                <span class="text-nowrap">Agregar rol</span>
              </b-button>
            </div>
          </b-col>
        </b-row>

      </div>

      <b-table
        ref="refUserListTable"
        class="position-relative"
        :items="roles"
        responsive
        :fields="tableColumns"
        :filter="searchQuery"
        primary-key="id"
        show-empty
        sticky-header
        fixed
        empty-text="No se encontraron registros"
      
      >

        <!-- Column: Actions -->
        <template #cell(actions)="data">
          <div variant="link"
            no-caret
            text-center
            :right="$store.state.appConfig.isRTL">
            <b-button variant="outline" :to="{ name: 'apps-roles-view', params: { id:  data.item.id} }"><feather-icon icon="FileTextIcon" /> Detalles</b-button>
            <b-button variant="outline" :to="{ name: 'apps-roles-edit', params: { id: data.item.id } }"><feather-icon icon="EditIcon" /> Editar</b-button>
            <b-button variant="outline" @click="deleteRole(data.item.id)"><feather-icon icon="TrashIcon" /> Eliminar</b-button>
          </div> 
        
        </template> -->

      </b-table>
      <div class="mx-2 mb-2">
        <b-row>

          <b-col
            cols="12"
            sm="6"
            class="d-flex align-items-center justify-content-center justify-content-sm-start"
          >
   
          </b-col>
         

        </b-row>
      </div>
    </b-card>
</template>

<script>
import BCardCode from '@core/components/b-card-code/BCardCode.vue'
import { BTable, BProgress, BBadge, BButton,BRow, BCol, BCard,BFormInput,} from 'bootstrap-vue'

export default {
  components: {
    BCardCode,
    BTable,
    BProgress,
    BBadge,
    BButton,
    BRow, 
    BCol, 
    BFormInput,
    BCard,
    BButton,
  },
  name:'roles-table',
  data(){
    return {
      roles:[],
      tableColumns:[
        { key: 'name',label:'Nombre', sortable: true },
      
        { key: 'actions',label:'Acciones',class:'text-center' },
      ],
      searchQuery:'',


    }
  },
  methods:{
    getRoles(){
      this.$http.get('roles').then(res=>{
        this.roles = res.data.roles
      }).catch(err=>{
        console.log(err)
      })
    },
    deleteRole(role){
      this.$swal({
        title: '¿Está seguro de eliminar el registro?',
        text: "No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, eliminar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          this.$http.get('roles/delete',{params:{role:role}}).then(res=>{
            this.$swal({
                icon: 'success',
                title: 'Eliminado!',
                text: 'El registro ha sido eliminado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
            this.getRoles()
          }).catch(err=>{
            console.log(err)
          })
      } else {
          this.$swal({
            title: 'Cancelado',
            text: 'El registro esta a salvo :)',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
    })
    }
    
  
    
  },
  mounted(){
    this.getRoles()

  },
}
</script>
